(function () {
    window.app = {
        query: function (name, href) {
            var reg = new RegExp("(^|\\?|&)" + name + "=([^&^\#]*)(\\s|&|\#|$)", "i");
            href = href || location.href;
            if (reg.test(href)) return decodeURIComponent(RegExp.$2.replace(/\+/g, " "));
            return "";
        },
        choose: (function () {
            var domain = document.domain;
            // var domain = 'penguin.h5.zjweishi.com';
            switch (domain) {
                case 'test.h5.arnoldlabs.com': //蚂蚁测试
                    return {
                        'androidUrl': 'antmalltest://' + domain, //安卓唤起app的url
                        'iosUrl': 'applinks://' + domain, //ios唤起app的url
                        'androidApk': 'https://antfile.oss-cn-beijing.aliyuncs.com/files/app-release_update.apk', //安卓唤起失败下载apk
                        'appleStore': 'https://itunes.apple.com/cn/app/id1371396127' // ios唤起失败跳转appleStore
                    }
                case 'h5.zrysp.cc': //蚂蚁
                    return {
                        'androidUrl': 'antmall://' + domain, 
                        'iosUrl': 'https://' + domain, 
                        'androidApk': 'https://antfile.oss-cn-beijing.aliyuncs.com/files/app-release_update.apk', 
                        'appleStore': 'https://itunes.apple.com/cn/app/id1371396127'
                    }
                case 'sesame.h5.blwhwl.com': //芝麻
                    return {
                        'androidUrl': 'sesamemall://' + domain, 
                        'iosUrl': 'applinks:' + domain, 
                        'androidApk': 'https://sesame2-apk.oss-cn-zhangjiakou.aliyuncs.com/files/app-sesame-release_update.apk', 
                        'appleStore': ''
                    }
                case 'origin.h5.chinabrainbank.com': //起点
                    return {
                        'androidUrl': 'originalmall://' + domain, 
                        'iosUrl': 'applinks:' + domain, 
                        'androidApk': 'https://origin-apk.oss-cn-beijing.aliyuncs.com/files/app-origin-release_update.apk', 
                        'appleStore': ''
                    }
                case 'penguin.h5.zjweishi.com': //企鹅
                    return {
                        'androidUrl': 'penguinmall://' + domain, 
                        'iosUrl': 'applinks:' + domain, 
                        'androidApk': 'https://penguin-apk.oss-cn-qingdao.aliyuncs.com/files/app-penguin-release_update.apk', 
                        'appleStore': ''
                    }
                default: //默认蚂蚁
                    return {
                        'androidUrl': 'antmall://h5.zrysp.cc', 
                        'iosUrl': 'applinks:h5.zrysp.cc', 
                        'androidApk': 'https://antfile.oss-cn-beijing.aliyuncs.com/files/app-release_update.apk', 
                        'appleStore': 'https://itunes.apple.com/cn/app/id1371396127'
                    }
            }
        })(),
        getUa: (function () {
            //根据useragent判断当前的设备类型
            var sUserAgent = navigator.userAgent.toLowerCase();
            var bIsIpad = sUserAgent.match(/ipad/i) == "ipad";
            var bIsIphoneOs = sUserAgent.match(/iphone os/i) == "iphone os";
            var bIsAndroid = sUserAgent.match(/android/i) == "android";
            var bIsWeixin = sUserAgent.match(/micromessenger/i) == "micromessenger";
            var bIsWeibo = sUserAgent.match(/weibo/i) == "weibo";
            var bIsqq = sUserAgent.match(/qq/i) == "qq";
            var bIsIosCoco = sUserAgent.match(/ios-coco/i) == "ios-coco";
            var bIsAndroidCoco = sUserAgent.match(/android-coco/i) == "android-coco";
            return {
                ipad: bIsIpad,
                iphone: bIsIphoneOs,
                android: bIsAndroid,
                weibo: bIsWeibo,
                weixin: bIsWeixin,
                qq: bIsqq,
                ios: bIsIphoneOs || bIsIpad,
                iosCoco: bIsIosCoco,
                androidCoco: bIsAndroidCoco,
                coco: bIsIosCoco || bIsAndroidCoco
            }
        })(),
        open: function (search) {
            // action=openUrl&url=https://penguin.h5.zjweishi.com/beginner/&isShowTitle=1&needLogin=0  打开指定h5页
            // recharge 充值   withdraw 提现   position 订单列表   tradeHistory 订单记录   voucherList 现金券列表  rechargeList 充值记录
            // action=chart&goodsType=XAGUSD  行情某个tab
            var _url;
            var unInstallCallBack = function () {
                if (app.getUa.ios) {
                    location.href = app.choose.appleStore;
                } else {
                    location.href = app.choose.androidApk;
                }
            };
            if (app.getUa.ios) {
                _url = search ? app.choose.iosUrl + search : app.choose.iosUrl;
            } else {
                _url = search ? app.choose.androidUrl + search : app.choose.androidUrl;
            }

            var openApp = function () {
                var iframe = document.createElement("iframe");
                iframe.style.display = "none";
                iframe.src = _url;
                document.body.appendChild(iframe);

                //保证所有浏览器能打开客户端，个别浏览器不支持iframe
                // window.location.href = _url;
                // console.log(_url)
                var aLink = document.createElement("a");
                aLink.style.display = "none";
                aLink.href = _url;
                document.body.appendChild(aLink);
                aLink.click();
                console.log(_url)
            };
            function _do() {
                var startTime = new Date().getTime();
                openApp();
                var interval = setTimeout(function () {
                    var delay = (new Date().getTime()) - startTime;
                    delay < 1020 && unInstallCallBack();
                }, 1000);

                /**
                 * 安卓注销callback， 大部分情况不好使
                 */
                window.onblur = function () {
                    interval && clearTimeout(interval);
                };
            }
            _do();
        }
    }
})()